import java.util.*;

public class Configuration {

	public static double globalClock;
	Vector<Task> conf;
	int capacity;
	Hashtable<Integer, Vector<String>> memory = new Hashtable<Integer, Vector<String>>();
	WorkingMemory workingMemory;
	
	
	//constructor
	public Configuration(){
		conf = new  Vector<Task>();
		globalClock = 0;
		workingMemory = new WorkingMemory(memory, capacity);
	}
	
	//METHOD ENABLED returns the set of task enabled at time gc:
    public Vector<Task> enabled(){
		Vector<Task> enabledTask = new Vector<Task>();
		for(Task t : conf){  
			//the tasks may be not completed 
			//with a state equal to "ongoing"
			//with a goal associated with them in memory //workingMemory.memory.get(t.taskId).contains("goal") &&
		   if(!t.completed() &&  t.status == "ongoing" && workingMemory.memory.get(t.taskId).contains(t.hd().information1)){
			   //not pausing
			  if(globalClock - t.timeStamp >= t.hd().delay) {    
				  enabledTask.add(t);
			  }
			}
		}
		return enabledTask;
	}
    
    

	//METHOD WAITINGTASKS returns all tasks not completed but with delay of the first basic task > 0
	public Vector<Task> waitingTasks(){
		Vector<Task> pausingTask = new Vector<Task>();
		for(Task t : conf){   
			//task not completed, with goal and status "ongoing"
		   if(!t.completed() && workingMemory.memory.get(t.taskId).contains("goal") && t.status == "ongoing"){
		      if(globalClock - t.timeStamp < t.hd().delay) {    
			     pausingTask.add(t);
			  }
		   }
		}
		return pausingTask;
	}	
	
	
	//completed method returns true if EVERY task in the configuration is accomplished
	public boolean completed(){  
		for(Task t : conf){
			if(t.status!= "completed" && t.status!="interrupted"){
				return false;
			}
		}
		return true;
	}
	
	
	//method to remove information when a basic task is executed.
	//if the information is not noInfo that information is deleted
	public void removeInformation(String information, int tid) {
		if(information != "noInfo") {
			if(workingMemory.memory.get(tid).contains(information)){
				 workingMemory.memory.get(tid).removeElement(information);
		    }else {
				 for(Task t : conf) {
					 if(t.taskId==tid) {
						t.status = "interrupted";
					 }
				 }
			}
		}

	}
	
	
	//METHOD ADDINFORMATION adds a new info in memory
    //check if the information is not noInfo  and adds it to the memory
	// if the memory would overload, call the method overload() which deletes a random info and then it adds the info
	public void addInformation(String information, int tid) {
		int itemsInMem=0;
		for(Integer i : workingMemory.memory.keySet()) {
			for(int j=0; j< workingMemory.memory.get(i).size(); j++) {
				itemsInMem ++;
			}
		}
		if(information != "noInfo") {
			  if(itemsInMem+1 > workingMemory.capacity) {
				 overload();
			  }
		   workingMemory.memory.get(tid).add(information);
		   }
    }
	
	
	//METHOD OVERLOAD    
	//to delete a random info and to update the status of the task in interrupted
	//it takes a task with a probability proportional to the task (globalclock -timeStamp) --the time the task
	//has not been executed -- and deletes a random info from its memory
	public void overload() {
		Vector <Integer> wtVector = new Vector<Integer>();
		Vector <Task> tVector = new Vector<Task>();
		
		
		
		int maxWT = 0;
		for(int a =0; a<conf.size(); a++) {
			maxWT += (globalClock - conf.get(a).timeStamp);
			wtVector.add(a, maxWT);
			tVector.add(a, conf.get(a));
		}
		
		Random rnd = new Random();
		int rndN = rnd.nextInt()*maxWT;
		
		
		int j=0;
		for(int b=0; b< wtVector.size(); b++) {
			if(rndN > wtVector.get(b)) {
				j = b;
			}
		}
	
		int chosenTaskId = tVector.get(j).taskId;
		
		int size=0;
		//take the memory associated to the task with minimum waitTime and memorizes its size
		for(Integer i : workingMemory.memory.keySet()) {
			if(chosenTaskId==i) {
				size = workingMemory.memory.get(i).size();
			}
		}
	
		//generates random number between 0 and the size of the chosen task
		Random rand = new Random();
		int randNo = rand.nextInt()* size;

		//delete a random info in the memory of the chosen task
		workingMemory.memory.get(chosenTaskId).removeElementAt(randNo); 

    }	

}
