import java.util.*;


public class Simulator {
	double maxWT =0;

	
	public Simulator() {
		
	}
	
	public double simulate(Configuration c) {
		//hashtable with vector of double which associates at each taskId the vector of waitTime of the task
		Hashtable<Integer, Vector<Double>> v = new Hashtable<Integer, Vector<Double>>();
		for(Task t3 : c.conf) {
			Vector<Double> tmp = new Vector<Double>();
			v.put(t3.taskId, tmp);
		}
	
		while(!c.completed()) {
			System.out.println("GLOBAL CLOCK: " + c.globalClock);

			//put the wait time of each task at each step of the interaction
			for(Task t : c.enabled()) {
				 v.get(t.taskId).add(c.globalClock- t.timeStamp-t.hd().delay);
			}
			//print the vector of the wait time
			for(Integer i : v.keySet()) {
				System.out.println("Task " + i + v.get(i));
			}
			

			for(Double d : v.get(c.conf.size())) {
				   maxWT = (maxWT < d ? d : maxWT);
			}
			
			
		
			if(c.enabled().size()!= 0) {
				System.out.println("Enabled tasks: ");
				for(Task t1 : c.enabled()) {
				   System.out.print("Task " + t1.taskId +"; ");
				   System.out.println();
				}
				
				//create two vectors, one for ranks one for tasks with the same index
				Vector<Double> rankVector = new Vector<Double>();
				Vector<Task> taskVector = new Vector<Task>();
				double maxAlpha=0;
				
				// full the two vectors with values
				int i=0;
				for(Task t : c.enabled()){
					maxAlpha += t.alpha();
					rankVector.add(i, maxAlpha);   
					taskVector.add(i, t);
					i++;
				}
				
				//generates a random number between 0 and maxAlpha
				Random rand = new Random();
			    double randomNo = rand.nextDouble()*maxAlpha;
			    //choose the index of the element with the highest alpha
			    int j=0;
				while(randomNo > rankVector.get(j)){
					j++;
				}
				
				//THE CHOSEN TASK IS THE ONE WITH INDEX J IN taskVector
				Task chosenTask = taskVector.get(j);
				
				System.out.println("The chosen task is " + chosenTask.taskId);
				
				//update globalClock
				c.globalClock += chosenTask.hd().duration;
				
				//update waitTime of chosenTask
				chosenTask.timeStamp = c.globalClock;
				
				//remove information from memory associated with chosenTask
				String inf1 = chosenTask.hd().information1;
				int taskId = chosenTask.taskId;
				c.removeInformation(inf1, taskId);
				
				//add new information in memory associated with chosenTask
				String inf2 = chosenTask.hd().information2;
				c.addInformation(inf2, taskId);
				
				//deletes the basic task just executed
				chosenTask.tl();
				
				//if the deleted basic task was the last one of the current subtask
				//call the task method update(), for removing the subtask 
				//and set the new cognitiveLoad.
				if(chosenTask.stSequence.get(0).emptySt()) {
					chosenTask.update();
				}
				
				//if the task is completed 
				//updates the status e removes it from memory
				if(chosenTask.completed()) { 
					chosenTask.status = "completed";
					c.workingMemory.memory.remove(taskId);
				}
				
				
				if(chosenTask.taskId==c.conf.size()-1) {
					return maxWT;
				}
				

			//all tasks are waiting for delays updates globalClock			
			}else if(c.waitingTasks().size()!=0){ 		
				System.out.println("Pausing tasks:");
				for(Task t2 : c.waitingTasks()) {
					System.out.println(t2.taskId);
					System.out.println();
				}
				double min=c.waitingTasks().get(0).timeStamp + c.waitingTasks().get(0).hd().delay;
				for(int i=1; i<c.waitingTasks().size(); i++) {
					double tmp = c.waitingTasks().get(i).timeStamp + c.waitingTasks().get(i).hd().delay;
					min= (min>tmp ? tmp : min);
				}
				c.globalClock=min;
				
			}

		}
	
		System.out.println("\r");
		System.out.println("GLOBAL CLOCK: " + c.globalClock);
		for(Task t : c.conf) {
			System.out.println("Task" + t.taskId + " alpha: " + t.alpha() + ", cognitive load: " + t.cognitiveLoad + ", wait time: " + (c.globalClock- t.timeStamp));

		}


		return 0;


	}
	


}